// keywivw.cpp : implementation of the CKeywinView class
//

#include "stdafx.h"
#include "keywin.h"

#include "keywidoc.h"
#include "keywivw.h"                                                   

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

char *Response;
char *Password;
char *Challenge;
/////////////////////////////////////////////////////////////////////////////
// CKeywinView


IMPLEMENT_DYNCREATE(CKeywinView, CFormView)

BEGIN_MESSAGE_MAP(CKeywinView, CFormView)
	//{{AFX_MSG_MAP(CKeywinView)
	ON_BN_CLICKED(IDC_COMPBUTT, OnCompbutt)
	ON_BN_CLICKED(IDC_COPYBUTT, OnCopybutt)
	ON_BN_CLICKED(IDC_PASTE_BUTTON, OnPasteButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeywinView construction/destruction

CKeywinView::CKeywinView()
	: CFormView(CKeywinView::IDD)
{
	//{{AFX_DATA_INIT(CKeywinView)
		m_Challenge = "";
		m_Password = "";             
		m_Response = "";
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	Challenge = m_Challenge.GetBuffer(BUFSIZ);
	m_Password.GetBuffer(BUFSIZ);
	m_Response.GetBuffer(BUFSIZ);
}

CKeywinView::~CKeywinView()
{
}

void CKeywinView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeywinView)
	DDX_Text(pDX, IDC_EDITCHAL, m_Challenge);
	DDX_Text(pDX, IDC_EDITPASS, m_Password);
	DDX_Text(pDX, IDC_EDITRESP, m_Response);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CKeywinView diagnostics

#ifdef _DEBUG
void CKeywinView::AssertValid() const
{
	CFormView::AssertValid();
}

void CKeywinView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CKeywinDoc* CKeywinView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CKeywinDoc)));
	return (CKeywinDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CKeywinView message handlers

extern "C" int	skey(char *, char *,char *);

void CKeywinView::OnCompbutt()
{
	char *challenge;         
	char *password;

	UpdateData(TRUE);
	if(m_Password == "") {
	  AfxMessageBox("you need to supply a password first");
	  return;
	}     
	challenge = m_Challenge.GetBuffer(BUFSIZ);
	Response = m_Response.GetBuffer(BUFSIZ);
	password = m_Password.GetBuffer(BUFSIZ);

	skey(challenge,password,Response);
	UpdateData(FALSE);
	
}


//
// Create a CF_TEXT Clipboard object from our data
//

HANDLE CreateCFTEXTObject(char *data, int length)
{
    HANDLE hData;
    LPSTR pData = NULL;

    //
    // Allocate the memory block
    //

    hData = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT,
                        length);
    if (!hData) {
        AfxMessageBox("Out of memory");
        return NULL;
    }

    pData = (LPSTR) GlobalLock(hData);
    _fmemcpy(pData, data, length);
    GlobalUnlock(hData);
    return hData;
}

void CKeywinView::OnCopybutt()
{
	HANDLE datahandle;
	
	UpdateData(TRUE);   
	if(!OpenClipboard()) {
	  AfxMessageBox("Cannot open the clipboard");
	  return;
	}
	if(!EmptyClipboard()) {
		AfxMessageBox("Cannot empty the clipboard");
		return;
	}
	strcat(Response,"\n");
	datahandle = CreateCFTEXTObject(Response,strlen(Response));
	
	if(!SetClipboardData(CF_TEXT,datahandle)) {
		AfxMessageBox("Cannot change clipboard");
	}
	CloseClipboard();
}

void CKeywinView::OnPasteButton()
{
	// TODO: Add your control notification handler code here
	HANDLE hClipMemory;
	HGLOBAL hMyMemory;        
	LPSTR pClipMemory;
	LPSTR pMyMemory;
	
	if(IsClipboardFormatAvailable(CF_TEXT)) {    
		if(!OpenClipboard()) {
			AfxMessageBox("unable to open clipboard");
			return;
		}
		hClipMemory = GetClipboardData(CF_TEXT);
		if (hClipMemory == NULL) {
			AfxMessageBox("Unable to get clipboard data");
			return;
		}
    	hMyMemory = GlobalAlloc(GHND,GlobalSize(hClipMemory));
		if (hMyMemory == NULL) {
			MessageBox("Out of Memory");
			CloseClipboard();
			return;
		}
		pClipMemory = (LPSTR)GlobalLock(hClipMemory); 
		pMyMemory = (LPSTR)GlobalLock(hMyMemory);
		lstrcpy(pMyMemory,pClipMemory);
		lstrcpy(Challenge,pMyMemory);
		UpdateData(FALSE);
		GlobalUnlock(hClipMemory);
		GlobalUnlock(hMyMemory);
		CloseClipboard();
	}
	
}
